/*	
 *	clipsn7.h
 *
 *	P/ECE SN79489/SN76496 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 12 18:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_SN7_H__
#define __CLIP_SN7_H__

/****************************************************************************
 *	
 ****************************************************************************/

/* Tone Channel (#0-2) */
typedef struct _SN79489TONE {
	int volume;		/*  (0`15) */
	int period;		/* o͋ɐ] */
	//
	int progress;		/* NbNisJE^ */
	int output;		/* o͋ɐ (0:/1:) */
} SN79489TONE;

/* Noise Channel (#3) */
typedef struct _SN79489NOISE {
	int volume;		/*  (0`15) */
	int period;		/* LFSRVtg */
	int feedback;		/* ^bvrbg */
	//
	int progress;		/* NbNisJE^ */
	int lfsr;		/* LFSR(Linear Feedback Shift Register) */
				/* LFSRbit0o͋ɐł (0:/1:) */
} SN79489NOISE;

/* SN79489 Chip */
typedef struct _SN79489 {
	int latch_channel;	/* b``lԍ */
	SN79489TONE tone[3];	/* g[`l0`2 */
	SN79489NOISE noise;	/* mCY`l */
	//
	DDA progress;		/* NbNisDDA */
} SN79489;

#define SN79489NOISE_PERIODIC	0x0001	/* mCỸ^bvrbg */
#define SN79489NOISE_WHITE	0x0009	/* zCgmCỸ^bvrbg() */

/****************************************************************************
 *	
 ****************************************************************************/

int sn79489_process(SN79489* sn, int cycle);
int sn79489_tone_process(SN79489* sn, SN79489TONE* tone, int cycle);
int sn79489_noise_process(SN79489* sn, SN79489NOISE* noise, int cycle);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* TODO:  */
void sn79489_reset(SN79489* sn, int clock);
void sn79489_write(SN79489* sn, unsigned char data);
void sn79489_mix(SN79489* sn, short wbuff[/*count*/], int count);

#endif /*__CLIP_SN7_H__*/
