/*	
 *	framsn7.c
 *
 *	P/ECE SN79489/SN76496 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 12 18:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/****************************************************************************
 *	
 ****************************************************************************/

int
sn79489_process(SN79489* sn, int cycle)
{
	int sample;

	/* t5bit~4t7bit */
	sample = sn79489_tone_process(sn, &sn->tone[0], cycle)
	       + sn79489_tone_process(sn, &sn->tone[1], cycle)
	       + sn79489_tone_process(sn, &sn->tone[2], cycle)
	       + sn79489_noise_process(sn, &sn->noise, cycle);
	sample <<= (16 - 7) + 1/**/;

	return sample;
}

int
sn79489_tone_process(SN79489* sn, SN79489TONE* tone, int cycle)
{
	int period;

	period = tone->period;
	if(!period) return 0;

	tone->progress += cycle;
	while(tone->progress >= period) {
		tone->progress -= period;
		tone->output = !tone->output;
	}

	return tone->output ? -tone->volume
			    :  tone->volume;
}

int
sn79489_noise_process(SN79489* sn, SN79489NOISE* noise, int cycle)
{
	int period, parity, n;

	period = noise->period;
	if(!period) period = sn->tone[2].period;
	if(!period) return 0;

	noise->progress += cycle;
	while(noise->progress >= period) {
		noise->progress -= period;
		parity = 0; /* peB */
		for(n = noise->lfsr & noise->feedback; n; n >>= 1) {
			parity ^= n & 1;
		}
		noise->lfsr = (noise->lfsr >> 1) | (parity << 15);
	}

	return noise->lfsr & 1 ? -noise->volume
			       :  noise->volume;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
sn79489_mix(SN79489* sn, short wbuff[/*count*/], int count)
{
	int cycle;
	int sample;

	while(count > 0) {
		/* o߃TCN߂܂B */
		cycle = sn->progress.u;
		sn->progress.d += sn->progress.n;
		if(sn->progress.d >= 0) {
			sn->progress.d -= SPEAKER_FREQUENCY;
			cycle++;
		}

		/* 1Tv~LVO܂B */
		sample = sn79489_process(sn, cycle);

		/* NbsOĊi[܂B */
		if(sample < -0x7fff) sample = -0x7fff;
		if(sample >  0x7fff) sample =  0x7fff;
		*wbuff++ = sample;

		/* cTv炵܂B */
		count--;
	}
}

